#pragma once

#include <Windows.h>

#define RECV_BUFF_SIZE	1024

class CComm
{
public:
	CComm();
	virtual ~CComm();

	virtual bool Open( void* p );
	virtual void Close();

	virtual DWORD Receive();
	virtual DWORD Transmit( const BYTE* pBuf, DWORD toWriteBytes );
	DWORD GetReceiveData( BYTE* pBuf );
	DWORD GetReceiveDataSize();
	void ClearReceiveBuffer();

protected:
	typedef struct {
		BYTE data[RECV_BUFF_SIZE];
		DWORD dwWp;
		DWORD dwRp;
		DWORD dwMax;
	} BUFFER;

	void WriteBuffer( BYTE* pData, DWORD dwSize );
	DWORD ReadBuffer( BYTE* pbuf );

	HANDLE mHThread;
	DWORD mThreadId;
	HANDLE mMutex;
	BUFFER mBuffer;
};
